  unit BallsG;
   interface
    uses  Crt, Windows, Graph ,  GraphMPP ,WindMPP ;

    const eps=1.0e-13; MaxReal=1.0e+13; nmax=25;

    type
         rar=Array[1..nmax] of real;
         iar=Array[1..nmax] of integer;
    var
         SoundOn                                 :boolean;
         irRings                                 :integer;
         BallsR, BallsX1,BallsX2,BallsY1,BallsY2,BallsB,Grav,
         BallsR4,RingsX1,RingsX2,RingsY1,RingsY2 :real;
         BallsTs                                 :rar;
         BallsJs,ixRings,iyRings,BallsColor      :iar;
         BallsMasse                : array[1..nmax] of real;


  procedure Rings(n:integer;var x,y;
                   color:integer;var inRings:integer; s: scl);

  procedure BallsDraw(n:integer;var x,y;
                                 var inRings:integer; s: scl);

  procedure Balls( n:integer; var x,y,vx,vy ;t:real; var inb:integer);


      Implementation

       type
         ReArray=array[1..25] of real;
         IntArray=array[0..25] of integer;

  procedure Rings(n:integer;var x,y;
                   color:integer;var inRings:integer; s:scl);
     var bc,i: integer; ixn,iyn:iar;

   begin
     bc:=CurWindow^.bkcol;
      if inRings=0 then
      begin
        irRings:=trunc(s[1]*BallsR+s[2]); inRings:=1;
        BallsX1:=RingsX1+BallsR; BallsX2:=RingsX2-BallsR;
        BallsY1:=RingsY1+BallsR; BallsY2:=RingsY2-BallsR;
      end;
      for i:=1 to n do
       begin
          ixn[i]:=trunc(s[1]*reArray(x)[i]+s[2]);
          iyn[i]:=trunc(s[3]*reArray(y)[i]+s[4]);
       end;
      for i:=1 to n do
       begin
        if inRings<>0 then
        begin SetColor(bc);
              Circle(ixRings[i],iyRings[i],irRings);
        end;
              SetColor(color);
              Circle(ixn[i],iyn[i],irRings);
      end;
      for i:=1 to n do
       begin
          ixRings[i]:=ixn[i]; iyRings[i]:=iyn[i];
          end;
             end; {Rings}

procedure BallsDraw(n:integer;var x,y;
                                 var inRings:integer; s: scl);
 var bc,i: integer; ixn,iyn:iar;

   begin
     bc:=CurWindow^.bkcol;
      if inRings=0 then
      begin
        irRings:=trunc(s[1]*BallsR+s[2]); inRings:=1;
        BallsX1:=RingsX1+BallsR; BallsX2:=RingsX2-BallsR;
        BallsY1:=RingsY1+BallsR; BallsY2:=RingsY2-BallsR;
      end;
      for i:=1 to n do
       begin
          ixn[i]:=trunc(s[1]*reArray(x)[i]+s[2]);
          iyn[i]:=trunc(s[3]*reArray(y)[i]+s[4]);
       end;
      for i:=1 to n do
       begin
        if inRings<>0 then
        begin SetColor(bc);
              Circle(ixRings[i],iyRings[i],irRings);
        end;
              SetColor(BallsColor[i]);
              Circle(ixn[i],iyn[i],irRings);
      end;
      for i:=1 to n do
       begin
          ixRings[i]:=ixn[i]; iyRings[i]:=iyn[i];
          end;
             end; {Rings}

procedure Balls( n:integer; var x,y,vx,vy ;t:real; var inb:integer);
        var i,j,ist,jst           : integer;
            tout,tt,dt,tsts       : real;
            f1,f2                 : boolean;

   procedure Change(n: integer; dt: real);
     var i: integer;

     begin  for i:=1 to n do
            begin reArray(x)[i]:=reArray(x)[i]+reArray(vx)[i]*dt;
                  reArray(y)[i]:=reArray(y)[i]+reArray(vy)[i]*dt
                                                 -Grav*sqr(dt)/2.0;
                  reArray(vy)[i]:=reArray(vy)[i]-Grav*dt;
                  BallsTs[i]:=BallsTs[i]-dt;
            end;
    end {Change};

   procedure Bump(n,i,j:integer);

    begin   BallsJs[i]:=i;
      if j<=n+2 then reArray(vx)[i]:=-reArray(vx)[i]
      else reArray(vy)[i]:=-reArray(vy)[i];
   end {Bump};


   procedure Stoss(n,i,j:integer);
        var xx,yy,g,du,dv: real;

    begin
      BallsJs[i]:=i; BallsJs[j]:=j;
      xx:=reArray(x)[j]-reArray(x)[i]; yy:=reArray(y)[j]-reArray(y)[i];
      du:=reArray(vx)[i]-reArray(vx)[j]; dv:=reArray(vy)[i]-reArray(vy)[j];
      g:=2*BallsB*(xx*du+yy*dv)/(BallsMasse[i]+BallsMasse[j]);
      du:=g*xx; dv:=g*yy;
      reArray(vx)[i]:=reArray(vx)[i]-BallsMasse[j]*du;
      reArray(vx)[j]:=reArray(vx)[j]+BallsMasse[i]*du;
      reArray(vy)[i]:=reArray(vy)[i]-BallsMasse[j]*dv;
      reArray(vy)[j]:=reArray(vy)[j]+BallsMasse[i]*dv;
      if SoundOn  then
      begin
      sound(860);delay(30);nosound;
      end;
   end {Stoss};

  procedure TBump(n,i:integer; var tb:real; var jb:integer);
    type where=(left,right,up,down,slowly);
    var tx,ty: real; jx,jy: integer; wx,wy: where;
        dis :real;
   begin
     if reArray(vx)[i]<-eps then wx:=left  else
     if reArray(vx)[i]> eps then wx:=right else
         wx:=slowly;
     dis:=sqr(reArray(vy)[i]/Grav)+2.0/Grav*(reArray(y)[i]-BallsY2);
     if (reArray(vy)[i]>0.0) and (dis>0.0) then wy:=up else
        wy:=down;

         case wx of
     left:   begin tx:=(BallsX1-reArray(x)[i])/reArray(vx)[i]; jx:=1; end;
     right:  begin tx:=(BallsX2-reArray(x)[i])/reArray(vx)[i]; jx:=2; end;
     slowly: begin tx:=MaxReal; jx:=1; end;
         end {case};

         case wy of
     up:     begin ty:=reArray(vy)[i]/Grav-sqrt(dis); jy:=4; end;
     down:   begin
          dis:=sqr(reArray(vy)[i]/Grav)+2.0/Grav*(reArray(y)[i]-BallsY1);
          ty:=reArray(vy)[i]/Grav+sqrt(dis); jy:=3; end;
         end {case};

     if ty>=tx then
          begin  tb:=tx; jb:=jx+n; end
     else begin  tb:=ty; jb:=jy+n; end;
  end {TBump};


  function TStoss(n,i,j: integer):real;
      var xx,yy,uu,vv,rv,v2,d: real;

   begin    TStoss:=MaxReal;
     if {1} i<>j then
      begin xx:=reArray(x)[i]-reArray(x)[j];
            yy:=reArray(y)[i]-reArray(y)[j];
            vv:=reArray(vy)[i]-reArray(vy)[j];
            uu:=reArray(vx)[i]-reArray(vx)[j];
            rv:=xx*uu+yy*vv;
        if {2} rv<0 then
         begin v2:=uu*uu+vv*vv;
          if {3} v2>eps then
           begin d:=rv*rv+v2*(BallsR4-xx*xx-yy*yy);
            if {4} d>0.0 then TStoss:=-(rv+sqrt(d))/v2;
           end {if3};
         end {if2};
     end {if1};
   end {TStoss};


    begin
      if inb=0 then begin
       BallsR4:=BallsR*BallsR*4.0;
        BallsX1:=RingsX1+BallsR; BallsX2:=RingsX2-BallsR;
        BallsY1:=RingsY1+BallsR; BallsY2:=RingsY2-BallsR;
       BallsB:=1.0/BallsR4;
      end;
          tout:=t; tsts:=0.0;
     while  tout>=tsts  do
      begin tout:=tout-tsts;
       for i:=1 to n do
        begin
         f1:=inb<>n;
         f2:=(BallsJs[i]=ist)or((BallsJs[i]=jst)and(jst<=n));
         if f1 then inb:=i;
         if f1 or ((not f1) and f2) then
          begin
            TBump(n,i,BallsTs[i],BallsJs[i]);
           for j:=1 to n do
            begin
             tt:=TStoss(n,i,j);
             if BallsTs[i]>tt then
                begin BallsTs[i]:=tt; BallsJs[i]:=j; end;
            end;
          end;
        end;
       tsts:=BallsTs[1]; ist:=1;
       for i:=2 to n do
        if BallsTs[i]<tsts then
         begin tsts:=BallsTs[i]; ist:=i;
         end;
       jst:=BallsJs[ist];
       if tout<tsts then dt:=tout else dt:=tsts;
       Change(n,dt);
       if tsts<=dt then
       if jst>n then Bump(n,ist,jst)
             else Stoss(n,ist,jst);
    end {while};
  end {Balls};



  var jj:integer;
  begin
     for jj:=1 to nmax do
       begin
         BallsMasse[jj]:=1.0;
         BallsColor[jj]:=((jj+7) mod 15)+1;
       end;
     SoundON:=false;  Grav:=1.0;
        BallsR:=20.0;
        RingsX1:=0.0; RingsX2:=256.0;
        RingsY1:=0.0; RingsY2:=256.0;
  end.

