unit Keystrok;
{  
}

{$A-,B-,F-,I+,R-,S+,V-}

interface

uses Crt;

function KeyPressed: boolean;

function ReadKey: word;

procedure WaitKey;

function UnAlt(key:word):word;

procedure OpenProtocol(name:string);

procedure CloseProtocol;

procedure ExecuteDemo(name:string);

procedure CloseDemo;

procedure DoNothing;

procedure DoNothingPar(line:string);

procedure DoNothingOn(on:boolean);

type
  DisplayDemoProc=procedure(line:string);
  FlushDemoProc=procedure;
  SignalProtocolProc=procedure(on:boolean);

var
  DisplayDemo: DisplayDemoProc;
  FlushDemo,EditDemo: FlushDemoProc;
  SignalProtocol: SignalProtocolProc;
  Demo: ^file;

const
  ProtocolOn: boolean = false;
  DemoOn: boolean = false;

const
  BackspaceKey=$0008;
  EnterKey=$000d;
  EscapeKey=$001b;
  TabKey=$0009;
  SpaceKey=$0020;
  F1Key=$3b00;
  F2Key=$3c00;
  F3Key=$3d00;
  F4Key=$3e00;
  F5Key=$3f00;
  F6Key=$4000;
  F7Key=$4100;
  F8Key=$4200;
  F9Key=$4300;
  F10Key=$4400;
  HomeKey=$4700;
  UpKey=$4800;
  PageUpKey=$4900;
  LeftKey=$4b00;
  RightKey=$4d00;
  EndKey=$4f00;
  DownKey=$5000;
  PageDownKey=$5100;
  InsertKey=$5200;
  DeleteKey=$5300;

  ShiftTabKey=$0f00;
  ShiftF1Key=$5400;
  ShiftF2Key=$5500;
  ShiftF3Key=$5600;
  ShiftF4Key=$5700;
  ShiftF5Key=$5800;
  ShiftF6Key=$5900;
  ShiftF7Key=$5a00;
  ShiftF8Key=$5b00;
  ShiftF9Key=$5c00;
  ShiftF10Key=$5d00;

  Ctrl2Key=$0300;
  Ctrl6Key=$001e;
  CtrlMinusKey=$001f;
  CtrlBackspaceKey=$007f;
  CtrlAKey=$0001;
  CtrlBKey=$0002;
  CtrlCKey=$0003;
  CtrlDKey=$0004;
  CtrlEKey=$0005;
  CtrlFKey=$0006;
  CtrlGKey=$0007;
  CtrlHKey=$0008;
  CtrlIKey=$0009;
  CtrlJKey=$000a;
  CtrlKKey=$000b;
  CtrlLKey=$000c;
  CtrlMKey=$000d;
  CtrlNKey=$000e;
  CtrlOKey=$000f;
  CtrlPKey=$0010;
  CtrlQKey=$0011;
  CtrlRKey=$0012;
  CtrlSKey=$0013;
  CtrlTKey=$0014;
  CtrlUKey=$0015;
  CtrlVKey=$0016;
  CtrlWKey=$0017;
  CtrlXKey=$0018;
  CtrlYKey=$0019;
  CtrlZKey=$001a;
  CtrlEnterKey=$000a;
  CtrlF1Key=$5e00;
  CtrlF2Key=$5f00;
  CtrlF3Key=$6000;
  CtrlF4Key=$6100;
  CtrlF5Key=$6200;
  CtrlF6Key=$6300;
  CtrlF7Key=$6400;
  CtrlF8Key=$6500;
  CtrlF9Key=$6600;
  CtrlF10Key=$6700;
  CtrlHomeKey=$7700;
  CtrlPageUpKey=$8400;
  CtrlLeftKey=$7300;
  CtrlRightKey=$7400;
  CtrlEndKey=$7500;
  CtrlPageDownKey=$7600;

  Alt1Key=$7800;
  Alt2Key=$7900;
  Alt3Key=$7a00;
  Alt4Key=$7b00;
  Alt5Key=$7c00;
  Alt6Key=$7d00;
  Alt7Key=$7e00;
  Alt8Key=$7f00;
  Alt9Key=$8000;
  Alt0Key=$8100;
  AltMinusKey=$8200;
  AltPlusKey=$8300;
  AltQKey=$1000;
  AltWKey=$1100;
  AltEKey=$1200;
  AltRKey=$1300;
  AltTKey=$1400;
  AltYKey=$1500;
  AltUKey=$1600;
  AltIKey=$1700;
  AltOKey=$1800;
  AltPKey=$1900;
  AltAKey=$1e00;
  AltSKey=$1f00;
  AltDKey=$2000;
  AltFKey=$2100;
  AltGKey=$2200;
  AltHKey=$2300;
  AltJKey=$2400;
  AltKKey=$2500;
  AltLKey=$2600;
  AltZKey=$2c00;
  AltXKey=$2d00;
  AltCKey=$2e00;
  AltVKey=$2f00;
  AltBKey=$3000;
  AltNKey=$3100;
  AltMKey=$3200;
  AltF1Key=$6800;
  AltF2Key=$6900;
  AltF3Key=$6a00;
  AltF4Key=$6b00;
  AltF5Key=$6c00;
  AltF6Key=$6d00;
  AltF7Key=$6e00;
  AltF8Key=$6f00;
  AltF9Key=$7000;
  AltF10Key=$7100;

const
  DemoBreakKey: word = F10Key;
  DemoEditKey: word = AltF10Key;
  ProtocolKey: word = AltF5Key;
  ProtocolCloseKey: word = AltF8Key;
  DemoName: string[12] = 'UNKNOWN.DEM';

implementation

var
  KeyPressedDelay: longint;
  DemoData: record
              delay: longint;
              key: word;
            end;
  DemoBroken,DemoAppend: boolean;

procedure ToProtocol(var buf; length:byte);
begin
  BlockWrite(Demo^,buf,length)
end;

procedure ReadDemo;
var
  line: string;
  display: boolean;
begin
  if Eof(Demo^) then begin
    DemoOn:=false;
    if DemoAppend then begin
      ProtocolOn:=true; KeyPressedDelay:=0
    end
  end else begin
    BlockRead(Demo^,DemoData,sizeof(DemoData));
    display:=DemoData.key=0;
    while DemoData.key=0 do begin
      line[0]:=Chr(Lo(DemoData.delay));
      BlockRead(Demo^,line[1],Ord(line[0]));
      DisplayDemo(line);
      BlockRead(Demo^,DemoData,sizeof(DemoData));
    end;
    if display then FlushDemo;
  end
end;

function ReadKeyboard: word;
var
  key: word;
  b: array[0..1] of byte absolute key;
begin
  key:=Ord(Crt.ReadKey);
  if key=0 then b[1]:=Ord(Crt.ReadKey);
  ReadKeyboard:=key;
end;

function KeyPressed: boolean;
var
  pressed: boolean;
  kbkey: word;
begin
  if DemoOn then with DemoData do begin
    if Crt.KeyPressed and not DemoBroken then begin
      kbkey:=ReadKeyboard;
      DemoBroken:=kbkey=DemoBreakKey;
      if kbkey=ProtocolKey then begin
        DemoAppend:=true; SignalProtocol(true)
      end else if kbkey=ProtocolCloseKey then begin
        DemoAppend:=false; SignalProtocol(false)
      end else if kbkey=DemoEditKey then begin
        EditDemo;
      end;
    end;
    pressed:=DemoBroken or (delay=0);
    if not pressed then Dec(delay);
  end else pressed:=Crt.KeyPressed;
  KeyPressed:=pressed;
  if ProtocolOn then begin
    if not pressed then Inc(KeyPressedDelay)
  end
end;

function ReadKey: word;
begin
  repeat until KeyPressed;
  if DemoOn then with DemoData do begin
    if DemoBroken then begin
      ReadKey:=DemoBreakKey; CloseDemo;
    end else begin
      ReadKey:=key; ReadDemo
    end;
  end else begin
    DemoData.key:=ReadKeyboard;
    if DemoData.key=ProtocolKey then begin
      OpenProtocol(DemoName); SignalProtocol(true);
      DemoData.key:=DemoBreakKey;
    end else if DemoData.key=ProtocolCloseKey then begin
      CloseProtocol; SignalProtocol(false);
      DemoData.key:=DemoBreakKey;
    end;
    ReadKey:=DemoData.key;
  end;
  if ProtocolOn and (DemoData.key<>DemoEditKey) then begin
    ToProtocol(KeyPressedDelay,Sizeof(KeyPressedDelay));
    ToProtocol(DemoData.key,Sizeof(DemoData.key)); KeyPressedDelay:=0;
  end;
  if DemoData.key=DemoEditKey then EditDemo;
end;

procedure WaitKey;
var
  key: word;
begin
  repeat until KeyPressed;
  key:=ReadKey
end;

function UnAlt(key:word):word;
const
  MinAlt=Hi(AltQKey);
  MaxAlt=Hi(AltMKey);
  C0=Chr(0);
  AltTable: array[MinAlt..MaxAlt] of char =
    ('Q','W','E','R','T','Y','U','I','O','P',C0,C0,C0,C0,'A','S',
     'D','F','G','H','J','K','L',C0,C0,C0,C0,C0,'Z','X','C','V',
     'B','N','M');
begin
  if Hi(key) in [MinAlt..MaxAlt] then UnAlt:=Ord(AltTable[Hi(key)]) else
    UnAlt:=0;
end;

procedure OpenProtocol(name:string);
begin
  if DemoOn then Exit;
  if ProtocolOn then CloseProtocol;
  New(Demo); Assign(Demo^,name);
  Rewrite(Demo^,1); KeyPressedDelay:=0; ProtocolOn:=true
end;

procedure CloseProtocol;
begin
  if not ProtocolOn then Exit;
  Close(Demo^); Dispose(Demo); ProtocolOn:=false;
end;

procedure ExecuteDemo(name:string);
begin
  if ProtocolOn then Exit;
  if DemoOn then CloseDemo;
  New(Demo); Assign(Demo^,name);
  Reset(Demo^,1); ReadDemo; DemoOn:=true;
  DemoBroken:=false; DemoAppend:=false;
end;

procedure CloseDemo;
begin
  if not DemoOn then Exit;
  Close(Demo^); Dispose(Demo); DemoOn:=false
end;

procedure DoNothing;
begin
end;

procedure DoNothingPar(line:string);
begin
end;

procedure DoNothingOn(on:boolean);
begin
end;

begin
  DisplayDemo:=DoNothingPar; FlushDemo:=DoNothing; EditDemo:=DoNothing;
  SignalProtocol:=DoNothingOn;
end.

