unit Memory;
{  ࠢ ᪮ }

{$A-,B-,F-,I+,R-,S+,V-}

interface

type
  memblock=record
             size: word;
             buf: array[0..256] of byte;
           end;
  memptr=^memblock;
  StringPtr=^string;

procedure Allocate(var p:memptr; size:word);

function ALotOfMemory:memptr;

function AllocateString(s:string):StringPtr;

procedure Free(var p:memptr);

procedure FreeString(var p:StringPtr);

function Mem(p:memptr):pointer;

procedure Shrink(var p:memptr; size:word); {for V5.5 delete var}

procedure CutMem(var p:pointer; init,new:word); {for V5.5 delete var}

implementation

{*********** memory management procedures ***********}

procedure Allocate(var p:memptr; size:word);
begin
  GetMem(p,size+2); p^.size:=size
end;

function ALotOfMemory:memptr;
var
  p: memptr;
  size: word;
begin
  if MaxAvail>65535-16 then size:=65535-16 else size:=MaxAvail;
  Allocate(p,size-2); ALotOfMemory:=p
end;

function AllocateString(s:string):StringPtr;
var
  p: StringPtr;
begin
  GetMem(p,Length(s)+1);
  Move(s,p^,Length(s)+1);
  AllocateString:=p
end;

procedure Free(var p:memptr);
begin
  if p<>nil then begin
    FreeMem(p,p^.size+2); p:=nil
  end
end;

procedure FreeString(var p:StringPtr);
begin
  FreeMem(p,Length(p^)+1);
  p:=nil
end;

function Mem(p:memptr):pointer;
begin
  Mem:=@p^.buf
end;

{********** old version (TP V5.5)**********
procedure Shrink(p:memptr; size:word);
var
  f: pointer;
  segm,off: word;
begin
  segm:=Seg(p^); off:=Ofs(p^)+size+2;
  Inc(segm,off div 16); off:=off mod 16;
  f:=Ptr(segm,off); FreeMem(f,p^.size-size);
  p^.size:=size
end;
}

procedure Shrink(var p:memptr; size:word);
var
  new: memptr;
begin
  Allocate(new,size); Move(p^.buf,new^.buf,size); Free(p); p:=new
end;

{********** old version (TP V5.5)**********
procedure CutMem(p:pointer; init,new:word);
var
  f: pointer;
  segm,off: word;
begin
  segm:=Seg(p^); off:=Ofs(p^)+init;
  Inc(segm,off div 16); off:=off mod 16;
  f:=Ptr(segm,off); FreeMem(f,init-new);
end;
}

procedure CutMem(var p:pointer; init,new:word);
var
  mem: pointer;
begin
  GetMem(mem,new); Move(p^,mem^,new); FreeMem(p,init); p:=mem
end;

begin
end.
